#include <stdio.h>
#include <string.h>

#include <mpi.h>
#include "MPI.h"

int len = 0;
char** sargs = 0;

/*
 * Class:     MPI
 * Method:    InitNative
 * Signature: ([Ljava/lang/String;)V
 */
JNIEXPORT void JNICALL Java_MPI_InitNative
  (JNIEnv *env, jclass obj, jobjectArray argv)
{
  jsize i;
  jstring jc;
  int flag, n;

  len = (*env)->GetArrayLength(env,argv) ;

  sargs = (char**)calloc(len+1, sizeof(char*));

  for (i=0; i<len; i++) {
    jc=(jstring)(*env)->GetObjectArrayElement(env,argv,i);
    sargs[i]= (char*)calloc(strlen((*env)->GetStringUTFChars(env,jc,0))+1,
			    sizeof(char));
    strcpy(sargs[i],(*env)->GetStringUTFChars(env,jc,0));
  }

  printf("len=%d \n",len);
  for(n=0;n<len;n++)
    printf("sargs[%d]=%s \n",n,sargs[n]);
   
  printf("Before MPI_Initialized ...\n");  /* debug */
  MPI_Initialized(&flag) ;  /* debug */
  printf("After MPI_Initialized... flag = %d\n", flag);

  printf("Before MPI_Init ...\n");
  MPI_Init(&len, &sargs);
  printf("After MPI_Init...\n");


}                                                   

/*
 * Class:     MPI
 * Method:    Finalize
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_MPI_Finalize
  (JNIEnv *env, jclass obj) {
  int i;

  printf("MPIFinalize...\n");

  MPI_Finalize();

  for (i=0; i<len; i++)
    free(sargs[i]);

  free(sargs);                            
}
                                             
